package com.rjconsultores.ventaboletos.dao.hibernate;

import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

import com.rjconsultores.ventaboletos.dao.TipoMovimentacionDAO;
import com.rjconsultores.ventaboletos.entidad.TipoMovimentacion;

@Repository("tipoMovimentacionDAO")
public class TipoMovimentacionHibernateDAO extends GenericHibernateDAO<TipoMovimentacion, Integer> implements TipoMovimentacionDAO {

	@Autowired
	public TipoMovimentacionHibernateDAO(
			@Qualifier("sessionFactory") SessionFactory factory) {
		setSessionFactory(factory);
	}

	@Override
	public List<TipoMovimentacion> obtenerTodos() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		
		return (List<TipoMovimentacion>)c.list();
	}

	@Override
	public TipoMovimentacion buscarTipoMovimentacio(int tipoMovimentacion) {
		
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.eq("tipomovimentacionId", tipoMovimentacion));
		
		return (TipoMovimentacion) c.uniqueResult();

	}

	@Override
	public List<TipoMovimentacion> obtenerTiposMovimetacionPuntoVenta() {
		Criteria c = getSession().createCriteria(getPersistentClass());
		c.add(Restrictions.eq(ACTIVO, Boolean.TRUE));
		c.add(Restrictions.in("tipomovimentacionId", new Integer[]{TipoMovimentacion.TIPO_ENVIO, TipoMovimentacion.TIPO_TRANSFERENCIA, TipoMovimentacion.TIPO_VOLVER}));
		
		return c.list();
	}
	
	
	
	
}
